commit 297d0efc13d73d36371583c2d6d6e7a47f88cd02
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Thu Apr 27 11:36:54 2023

    c: Fix up error-recovery on non-empty VLA initializers [PR109409]
    
    On the following testcase we ICE, because after we emit the
    variable-sized object may not be initialized except with an empty initializer
    error we don't really reset the initializer to error_mark_node and then at
    -Wformat checking time we ICE on seeing STRING_CST initializer for a VLA.
    
    The following patch just arranges for error_mark_node to be returned after
    the error diagnostics.
    
    2023-04-27  Jakub Jelinek  <jakub@redhat.com>
    
            PR c/109409
            * c-parser.cc (c_parser_initializer): Move diagnostics about
            initialization of variable sized object with non-empty initializer
            after c_parser_expr_no_commas call and ret.set_error (); after it.
    
            * gcc.dg/pr109409.c: New test.
    
    (cherry picked from commit d8842271ebf9a81128df9ae80e1d3b688749eac8)

diff --git a/gcc/c/c-parser.cc b/gcc/c/c-parser.cc
index 21bc3167ce2..3627a3fbdc7 100644
--- a/gcc/c/c-parser.cc
+++ b/gcc/c/c-parser.cc
@@ -5677,11 +5677,14 @@ c_parser_initializer (c_parser *parser, tree decl)
     {
       struct c_expr ret;
       location_t loc = c_parser_peek_token (parser)->location;
-      if (decl != error_mark_node && C_DECL_VARIABLE_SIZE (decl))
-	error_at (loc,
-		  "variable-sized object may not be initialized except "
-		  "with an empty initializer");
       ret = c_parser_expr_no_commas (parser, NULL);
+      if (decl != error_mark_node && C_DECL_VARIABLE_SIZE (decl))
+	{
+	  error_at (loc,
+		    "variable-sized object may not be initialized except "
+		    "with an empty initializer");
+	  ret.set_error ();
+	}
       /* This is handled mostly by gimplify.cc, but we have to deal with
 	 not warning about int x = x; as it is a GCC extension to turn off
 	 this warning but only if warn_init_self is zero.  */
diff --git a/gcc/testsuite/gcc.dg/pr109409.c b/gcc/testsuite/gcc.dg/pr109409.c
new file mode 100644
index 00000000000..097a511c07e
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/pr109409.c
@@ -0,0 +1,10 @@
+/* PR c/109409 */
+/* { dg-do compile } */
+/* { dg-options "-Wall" } */
+
+void
+foo (int n)
+{
+  const char c[n] = "1";	/* { dg-error "variable-sized object may not be initialized except with an empty initializer" } */
+  __builtin_printf (c);
+}

